poj 2184 Cow Exhibition(dp之01背包变形)

Description

"Fat and docile, big and dumb, they look so stupid, they aren‘t much
fun..."
- Cows with Guns by Dana Lyons 

The cows want to prove to the public that they are both smart and fun. In order to do this, Bessie has organized an exhibition that will be put on by the cows. She has given each of the N (1 <= N <= 100) cows a thorough interview and determined two values for each cow: the smartness Si (-1000 <= Si <= 1000) of the cow and the funness Fi (-1000 <= Fi <= 1000) of the cow. 

Bessie must choose which cows she wants to bring to her exhibition. She believes that the total smartness TS of the group is the sum of the Si‘s and, likewise, the total funness TF of the group is the sum of the Fi‘s. Bessie wants to maximize the sum of TS and TF, but she also wants both of these values to be non-negative (since she must also show that the cows are well-rounded; a negative TS or TF would ruin this). Help Bessie maximize the sum of TS and TF without letting either of these values become negative. 

Input

* Line 1: A single integer N, the number of cows 

* Lines 2..N+1: Two space-separated integers Si and Fi, respectively the smartness and funness for each cow. 

Output

* Line 1: One integer: the optimal sum of TS and TF such that both TS and TF are non-negative. If no subset of the cows has non-negative TS and non- negative TF, print 0. 

Sample Input

5
-5 7
8 -6
6 -3
2 1
-8 -5

Sample Output

8

Hint

OUTPUT DETAILS: 

Bessie chooses cows 1, 3, and 4, giving values of TS = -5+6+2 = 3 and TF
= 7-3+1 = 5, so 3+5 = 8. Note that adding cow 2 would improve the value
of TS+TF to 10, but the new value of TF would be negative, so it is not
allowed. 

Source

USACO 2003 Fall

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 #include<algorithm>
 5 #include<cmath>
 6 #include<stdlib.h>
 7 using namespace std;
 8 #define inf 1<<30
 9 #define N 106
10 int dp[200006];
11 int a[N],b[N];
12 int main()
13 {
14     int n;
15     while(scanf("%d",&n)==1){
16         for(int i=0;i<n;i++){
17             scanf("%d%d",&a[i],&b[i]);
18         }
19         //memset(dp,inf,sizeof(dp));
20         for(int i=0;i<200006;i++){
21             dp[i]=-inf;
22         }
23         dp[100000]=0;
24         for(int i=0;i<n;i++){
25             //if(a[i]<0 && b[i]<0) continue;
26             if(a[i]>0){
27                 for(int j=200000;j>=a[i];j--){
28                     dp[j]=max(dp[j],dp[j-a[i]]+b[i]);
29                 }
30             }
31             else{
32                 for(int j=a[i];j<=200000+a[i];j++){
33                     dp[j]=max(dp[j],dp[j-a[i]]+b[i]);
34                 }
35             }
36         }
37         int ans=0;
38         for(int i=100000;i<=200000;i++){
39             if(dp[i]>=0){
40                 ans=max(ans,dp[i]+i-100000);
41             }
42         }
43         printf("%d\n",ans);
44     }
45     return 0;
46 }

题意:每行给出si和fi,代表牛的两个属性,然后要求选出几头牛,是的则求出总S与总F的和,注意S与F都不能为负数

思路:很明显的就是取与不取的问题,对于这类问题的第一想法就是背包,但是这道题目很明显与一般的背包不同,因为有负数,但是联想到以前也有这种将负数存入下标的情况,那就是将数组开大,换一种存法

我们用dp[i]存放每个s[i]能得到的最佳F,那么我们就可以根据s[i]的取值采取两种不同的01背包取法,在取完之后,然后再根据背包的有无再去求得最佳答案即可

附上大神代码:

 1 #include <stdio.h>
 2 #include <string.h>
 3 #include <algorithm>
 4 using namespace std;
 5
 6 int dp[200005];
 7 const int inf = 1<<30;
 8
 9 int main()
10 {
11     int n,s[200],f[200],i,j,ans;
12     while(~scanf("%d",&n))
13     {
14         for(i = 0; i<=200000; i++)
15             dp[i] = -inf;
16         dp[100000] = 0;
17         for(i = 1; i<=n; i++)
18             scanf("%d%d",&s[i],&f[i]);
19         for(i = 1; i<=n; i++)
20         {
21             if(s[i]<0 && f[i]<0)
22                 continue;
23             if(s[i]>0)
24             {
25                 for(j = 200000; j>=s[i]; j--)//如果s[i]为整数,那么我们就从大的往小的方向进行背包
26                     if(dp[j-s[i]]>-inf)
27                         dp[j] = max(dp[j],dp[j-s[i]]+f[i]);
28             }
29             else
30             {
31                 for(j = s[i]; j<=200000+s[i]; j++)//为负数则需要反过来
32                     if(dp[j-s[i]]>-inf)
33                         dp[j] = max(dp[j],dp[j-s[i]]+f[i]);
34             }
35         }
36         ans = -inf;
37         for(i = 100000; i<=200000; i++)//因为区间100000~200000才是表示的整数,那么此时的i就是之前背包中的s[i],如果此时dp[i]也就是f[i]大于等于0的话,我们再加上s[i](此时为i),然后减去作为界限的100000,就可以得到答案
38         {
39             if(dp[i]>=0)
40                 ans = max(ans,dp[i]+i-100000);
41         }
42         printf("%d\n",ans);
43     }
44
45     return 0;
46 }

时间: 2024-12-14 09:23:18

poj 2184 Cow Exhibition(dp之01背包变形)的相关文章

poj 2184 Cow Exhibition 【另类01背包】

Cow Exhibition Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 9424   Accepted: 3619 Description "Fat and docile, big and dumb, they look so stupid, they aren't much fun..." - Cows with Guns by Dana Lyons The cows want to prove to t

poj 2184 Cow Exhibition (变形的01背包)

链接:poj 2184 题意:给定n头牛,每头牛的的智商(si)和幽默感(fi)已知,求在保证智商(S)的和及幽默感(F)的和都为非负的情况下,智商和幽默感(S+T)的最大值 分析:题的本质即从n头牛中选出S>=0&&T>=0时,S+T的最大值 以智商最为容量,幽默感作为价值,因为每头牛只能选一次,就转化01背包了, dp[i]为智商为i时幽默感的最大值,则状态转移方程为 dp[j]=max(dp[j],dp[j-s[i]]+f[i]); 但是智商总和范围-100000~100

poj 2184 Cow Exhibition(01背包)

Cow Exhibition Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10882   Accepted: 4309 Description "Fat and docile, big and dumb, they look so stupid, they aren't much fun..." - Cows with Guns by Dana Lyons The cows want to prove to

poj 2184 - Cow Exhibition (01背包) 解题报告

Cow Exhibition Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10279   Accepted: 4016 Description "Fat and docile, big and dumb, they look so stupid, they aren't much fun..." - Cows with Guns by Dana Lyons The cows want to prove to

POJ 2184 Cow Exhibition (01背包)

题意:每行给出si和fi,代表牛的两个属性,然后要求选出几头牛,是的则求出总S与总F的和,注意S与F都不能为负数 析:用dp[i]来表示存放s[i]的时最大的f[i],其实就是一个01背包.只是取不取的关系.注意是有负数,所以把数组开大一点,然后s[i]的正负数, 我们取的顺序不同,正数是逆向,负数是正向,要不然可能有重复.还不知道为什么交G++就RE,交C++就能过. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000&quo

poj(2184)——Cow Exhibition(01背包变形)

其实我想说这道题我觉得我自己并没有深刻的理解.但是今天做了一下,先把现在的想法记录下来 . 题目的大致意思是: 有N头牛,每头牛都有一个s值代表智商值,f值代表它的幽默值. 然后问你智商值和幽默值的总和值最大是多少,其中必须保证智商值的和与幽默值的和为非负数. 一开始我想到的也是01背包,但是这里还有负值,于是我就没有办法了.于是学习到了一个相当于把坐标平移的方法. 因为这里有-1000到0的值,于是我们把它们全都移到右边去,于是变成了非负值0-2000. 解法: 01背包. 但是要注意的是当x

poj 2184 Cow Exhibition 01背包变形

点击打开链接链接 Cow Exhibition Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 9288   Accepted: 3551 Description "Fat and docile, big and dumb, they look so stupid, they aren't much fun..." - Cows with Guns by Dana Lyons The cows want to p

POJ 2184 Cow Exhibition 奶牛展(01背包,严重变形)

题意:有只奶牛要证明奶牛不笨,所以要带一些奶牛伙伴去证明自己.牛有智商和幽默感,两者可为负的(难在这),要求所有牛的智商和之 / 幽默感之和都不为负.求两者之和的最大值. 思路:每只牛可以带或不带上,是01背包问题.但是问题是没有明显的背包容量限制,却有了不为负的一些限制,相同的是要求最大和.必须找个背包容量出来. 1)背包容量:可以使用幽默感之和或智商之和作为背包容量.两者是提供的有明确范围的. 2)负号的问题:牛最多100只,而智商与幽默感最多为正负1千,那么 -1000*100<=x<=

POJ 2184 Cow Exhibition (变种01背包)

题意:有一些奶牛,他们有一定的s值和f值,这些值有正有负,最后让保证s的和为非负且f的和为非负的情况下,s+f的最大值. 思路:很明显的就是取与不取的问题,对于这类问题的第一想法就是背包,但是这道题目很明显与一般的背包不同,因为有负数,但是联想到以前也有这种将负数存入下标的情况,那就是将数组开大,换一种存法 我们用dp[i]存放每个s[i]能得到的最佳F,那么我们就可以根据s[i]的取值采取两种不同的01背包取法,在取完之后,然后再根据背包的有无再去求得最佳答案即可 #include <stdi